if (!defined &_SYS_FLOCK_IMPL_H) {
    eval 'sub _SYS_FLOCK_IMPL_H {1;}';
    require 'sys/types.ph';
    require 'sys/fcntl.ph';
    require 'sys/file.ph';
    require 'sys/flock.ph';
    require 'sys/kmem.ph';
    require 'sys/user.ph';
    require 'sys/thread.ph';
    require 'sys/proc.ph';
    require 'sys/cred.ph';
    require 'sys/debug.ph';
    require 'sys/cmn_err.ph';
    require 'sys/errno.ph';
    require 'sys/systm.ph';
    require 'sys/vnode.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub ACTIVE_LOCK {0x0001;}';
    eval 'sub SLEEPING_LOCK {0x0002;}';
    eval 'sub IO_LOCK {0x0004;}';
    eval 'sub REFERENCED_LOCK {0x0008;}';
    eval 'sub QUERY_LOCK {0x0010;}';
    eval 'sub WILLING_TO_SLEEP_LOCK {0x0020;}';
    eval 'sub RECOMPUTE_LOCK {0x0040;}';
    eval 'sub RECOMPUTE_DONE {0x0080;}';
    eval 'sub BARRIER_LOCK {0x0100;}';
    eval 'sub GRANTED_LOCK {0x0200;}';
    eval 'sub CANCELLED_LOCK {0x0400;}';
    eval 'sub DELETED_LOCK {0x0800;}';
    eval 'sub INTERRUPTED_LOCK {0x1000;}';
    eval 'sub LOCKMGR_LOCK {0x2000;}';
    eval 'sub HASH_SIZE {32;}';
    eval 'sub HASH_SHIFT {( &HASH_SIZE - 1);}';
    eval 'sub HASH_INDEX {
        local($vp) = @_;
        eval "(($vp >> 7) &  &HASH_SHIFT)";
    }';
    eval 'sub SAME_OWNER {
        local($lock1, $lock2) = @_;
        eval "((($lock1)-> &l_flock. &l_pid == ($lock2)-> &l_flock. &l_pid) && (($lock1)-> &l_flock. &l_sysid == ($lock2)-> &l_flock. &l_sysid))";
    }';
    eval 'sub NO_COLOR {0;}';
    eval 'sub NO_CHECK_CYCLE {0;}';
    eval 'sub CHECK_CYCLE {1;}';
    eval 'sub COLORED {
        local($vertex) = @_;
        eval "(($vertex)-> &l_color == ($vertex)-> &l_graph-> &mark)";
    }';
    eval 'sub COLOR {
        local($vertex) = @_;
        eval "(($vertex)-> &l_color = ($vertex)-> &l_graph-> &mark)";
    }';
    eval 'sub STACK_INIT {
        local($stack) = @_;
        eval "(($stack) =  &NULL)";
    }';
    eval 'sub STACK_PUSH {
        local($stack, $ptr, $stack_link) = @_;
        eval "($ptr)->$stack_link = ($stack), ($stack) = ($ptr)";
    }';
    eval 'sub STACK_POP {
        local($stack, $stack_link) = @_;
        eval "($stack) = ($stack)->$stack_link";
    }';
    eval 'sub STACK_TOP {
        local($stack) = @_;
        eval "($stack)";
    }';
    eval 'sub STACK_EMPTY {
        local($stack) = @_;
        eval "(($stack) ==  &NULL)";
    }';
    eval 'sub ACTIVE_HEAD {
        local($gp) = @_;
        eval "(&($gp)-> &active_locks)";
    }';
    eval 'sub SLEEPING_HEAD {
        local($gp) = @_;
        eval "(&($gp)-> &sleeping_locks)";
    }';
    eval 'sub SET_LOCK_TO_FIRST_ACTIVE_VP {
        local($gp, $lock, $vp) = @_;
        eval "{ ($lock) = ( &lock_descriptor_t *) $vp-> &v_filocks; }";
    }';
    eval 'sub SET_LOCK_TO_FIRST_SLEEP_VP {
        local($gp, $lock, $vp) = @_;
        eval "{  &for (($lock) =  &SLEEPING_HEAD(($gp))-> &l_next; (($lock) !=  &SLEEPING_HEAD(($gp)) && ($lock)-> &l_vnode != ($vp)); ($lock) = ($lock)-> &l_next) ; ($lock) = (($lock) ==  &SLEEPING_HEAD(($gp))) ?  &NULL : ($lock); }";
    }';
    eval 'sub OVERLAP {
        local($lock1, $lock2) = @_;
        eval "((($lock1)-> &l_start <= ($lock2)-> &l_start && ($lock2)-> &l_start <= ($lock1)-> &l_end) || (($lock2)-> &l_start <= ($lock1)-> &l_start && ($lock1)-> &l_start <= ($lock2)-> &l_end))";
    }';
    eval 'sub IS_QUERY_LOCK {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &QUERY_LOCK)";
    }';
    eval 'sub IS_RECOMPUTE {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &RECOMPUTE_LOCK)";
    }';
    eval 'sub IS_SLEEPING {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &SLEEPING_LOCK)";
    }';
    eval 'sub IS_BARRIER {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &BARRIER_LOCK)";
    }';
    eval 'sub IS_GRANTED {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &GRANTED_LOCK)";
    }';
    eval 'sub IS_CANCELLED {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &CANCELLED_LOCK)";
    }';
    eval 'sub IS_DELETED {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &DELETED_LOCK)";
    }';
    eval 'sub IS_REFERENCED {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &REFERENCED_LOCK)";
    }';
    eval 'sub IS_IO_LOCK {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &IO_LOCK)";
    }';
    eval 'sub IS_WILLING_TO_SLEEP {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &WILLING_TO_SLEEP_LOCK)";
    }';
    eval 'sub IS_ACTIVE {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &ACTIVE_LOCK)";
    }';
    eval 'sub IS_INTERRUPTED {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &INTERRUPTED_LOCK)";
    }';
    eval 'sub IS_LOCKMGR {
        local($lock) = @_;
        eval "(($lock)-> &l_state &  &LOCKMGR_LOCK)";
    }';
    eval 'sub IS_LOCAL {
        local($lock) = @_;
        eval "(($lock)-> &l_flock. &l_sysid == 0)";
    }';
    eval 'sub IS_REMOTE {
        local($lock) = @_;
        eval "(!  &IS_LOCAL($lock))";
    }';
    eval 'sub BLOCKS {
        local($lock1, $lock2) = @_;
        eval "(! &SAME_OWNER(($lock1), ($lock2)) && ((($lock1)-> &l_type ==  &F_WRLCK) || (($lock2)-> &l_type ==  &F_WRLCK)) &&  &OVERLAP(($lock1), ($lock2)))";
    }';
    eval 'sub COVERS {
        local($lock1, $lock2) = @_;
        eval "((($lock1)-> &l_start <= ($lock2)-> &l_start) && (($lock1)-> &l_end >= ($lock2)-> &l_end))";
    }';
    eval 'sub IN_LIST_REMOVE {
        local($ep) = @_;
        eval "{ ($ep)-> &edge_in_next-> &edge_in_prev = ($ep)-> &edge_in_prev; ($ep)-> &edge_in_prev-> &edge_in_next = ($ep)-> &edge_in_next; }";
    }';
    eval 'sub ADJ_LIST_REMOVE {
        local($ep) = @_;
        eval "{ ($ep)-> &edge_adj_next-> &edge_adj_prev = ($ep)-> &edge_adj_prev; ($ep)-> &edge_adj_prev-> &edge_adj_next = ($ep)-> &edge_adj_next; }";
    }';
    eval 'sub NOT_BLOCKED {
        local($lock) = @_;
        eval "(($lock)-> &l_edge. &edge_adj_next == &($lock)-> &l_edge && ! &IS_GRANTED($lock))";
    }';
    eval 'sub GRANT_WAKEUP {
        local($lock) = @_;
        eval "{ ($lock)-> &l_state |=  &GRANTED_LOCK;  &cv_signal(&($lock)-> &l_cv); }";
    }';
    eval 'sub CANCEL_WAKEUP {
        local($lock) = @_;
        eval "{ ($lock)-> &l_state |=  &CANCELLED_LOCK;  &cv_signal(&($lock)-> &l_cv); }";
    }';
    eval 'sub INTERRUPT_WAKEUP {
        local($lock) = @_;
        eval "{ ($lock)-> &l_state |=  &INTERRUPTED_LOCK;  &cv_signal(&($lock)-> &l_cv); }";
    }';
    eval 'sub REMOVE_SLEEP_QUEUE {
        local($lock) = @_;
        eval "{  &ASSERT( &IS_SLEEPING($lock)); ($lock)-> &l_state &= ~ &SLEEPING_LOCK; ($lock)-> &l_next-> &l_prev = ($lock)-> &l_prev; ($lock)-> &l_prev-> &l_next = ($lock)-> &l_next; ($lock)-> &l_next = ($lock)-> &l_prev = ( &lock_descriptor_t *)  &NULL; }";
    }';
    eval 'sub NO_DEPENDENTS {
        local($lock) = @_;
        eval "(($lock)-> &l_edge. &edge_in_next == &($lock)-> &l_edge)";
    }';
    eval 'sub GRANT {
        local($lock) = @_;
        eval "(($lock)-> &l_state |=  &GRANTED_LOCK)";
    }';
    eval 'sub FIRST_IN {
        local($lock) = @_;
        eval "(($lock)-> &l_edge. &edge_in_next)";
    }';
    eval 'sub FIRST_ADJ {
        local($lock) = @_;
        eval "(($lock)-> &l_edge. &edge_adj_next)";
    }';
    eval 'sub HEAD {
        local($lock) = @_;
        eval "(&($lock)-> &l_edge)";
    }';
    eval 'sub NEXT_ADJ {
        local($ep) = @_;
        eval "(($ep)-> &edge_adj_next)";
    }';
    eval 'sub NEXT_IN {
        local($ep) = @_;
        eval "(($ep)-> &edge_in_next)";
    }';
    eval 'sub IN_ADJ_INIT {
        local($lock) = @_;
        eval "{ ($lock)-> &l_edge. &edge_adj_next = ($lock)-> &l_edge. &edge_adj_prev = &($lock)-> &l_edge; ($lock)-> &l_edge. &edge_in_next = ($lock)-> &l_edge. &edge_in_prev = &($lock)-> &l_edge; }";
    }';
    eval 'sub COPY {
        local($lock1, $lock2) = @_;
        eval "{ ($lock1)-> &l_graph = ($lock2)-> &l_graph; ($lock1)-> &l_vnode = ($lock2)-> &l_vnode; ($lock1)-> &l_type = ($lock2)-> &l_type; ($lock1)-> &l_start = ($lock2)-> &l_start; ($lock1)-> &l_end = ($lock2)-> &l_end; ($lock1)-> &l_flock = ($lock2)-> &l_flock; ($lock1)-> &pvertex = ($lock2)-> &pvertex; }";
    }';
    eval 'sub UNLOCK {0x1;}';
    eval 'sub DOWNGRADE {0x2;}';
    eval 'sub UPGRADE {0x3;}';
    eval 'sub STAY_SAME {0x4;}';
    eval 'sub PROC_CHUNK {100;}';
    eval 'sub PROC_SAME_OWNER {
        local($lock, $pvertex) = @_;
        eval "((($lock)-> &l_flock. &l_pid == ($pvertex)-> &pid) && (($lock)-> &l_flock. &l_sysid == ($pvertex)-> &sysid))";
    }';
    eval 'sub PROC_ARRIVE {
        local($pvertex) = @_;
        eval "(($pvertex)-> &atime =  &pgraph. &mark)";
    }';
    eval 'sub PROC_DEPART {
        local($pvertex) = @_;
        eval "(($pvertex)-> &dtime =  &pgraph. &mark)";
    }';
    eval 'sub PROC_ARRIVED {
        local($pvertex) = @_;
        eval "(($pvertex)-> &atime ==  &pgraph. &mark)";
    }';
    eval 'sub PROC_DEPARTED {
        local($pvertex) = @_;
        eval "(($pvertex)-> &dtime ==  &pgraph. &mark)";
    }';
    if (defined &__cplusplus) {
    }
}
1;
